using System;
using UnityEngine;

namespace NeMech {
	public class OVLrange : MVRScript {

		const string virsionMmsg = "<b>=== OVLrange V1.0 ===</b>\n" + 
		                           "FC Content.\n" +
		                           "OVLrange.cs\n\n" +
		                           "Created by NeMech in 2024/4\n" +
		                           "https://www.patreon.com/nemech";

		protected JSONStorableString jstring;
		protected UIDynamicTextField dtext;
		private RectTransform rt3 = null;
		
		private JSONStorableBool manuaToggle;
		protected UIDynamicToggle toggleUI;
		
		public override void Init() {
			try {
				// JSONStorableString
				jstring = new JSONStorableString("ContensMessage", virsionMmsg );
				dtext = CreateTextField(jstring);
				dtext.height=300f;
				

				// JSONStorableToggle *** Enable cheak box **** 
				manuaToggle = new JSONStorableBool("manuaToggle", true, toggleCallback);
				RegisterBool(manuaToggle);
				toggleUI = CreateToggle(manuaToggle, false);            	

			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}
		
		private bool error = false;
		void Start(){
				GameObject _OVLText = GameObject.Find("SubtitlesText");
				if(_OVLText == null){
					SuperController.LogError("VAMOVLrange : VAMOverlays not Found!");
					jstring.val = jstring.val + "<color=yellow>\n<size=40><b>Error\nVAMOverlays not Found!</b></size></color>";
					error = true;
				} else {
					rt3 = _OVLText.GetComponent<RectTransform>();
			        rt3.SetSizeWithCurrentAnchors(RectTransform.Axis.Horizontal, 4096f);
				}
			toggleCallback(manuaToggle);
		}

		private void toggleCallback(JSONStorableBool jf)
		{
			if(error == true) return;
			if(jf.val == true )
				rt3.SetSizeWithCurrentAnchors(RectTransform.Axis.Vertical, 2160f);
			else
				rt3.SetSizeWithCurrentAnchors(RectTransform.Axis.Vertical, 3780f);
		}
	}	
}

